#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_shop.h"
std::auto_ptr<M_shop> M_shop::msSingleton(nullptr);

int M_shop::GetCount()
{
	return (int)mMapData.size();
}

const M_shopData* M_shop::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_shopData>& M_shop::GetMapData()
{
	return mMapData;
}

void M_shop::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_shop.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_shopData data;
		data.mID = element->IntAttribute("ID");
		data.mshop_type = element->IntAttribute("shop_type");
		{
			const char* cost_Item = element->Attribute("cost_Item");
			std::vector<std::string> veccost_Item;
			boost::split(veccost_Item, cost_Item, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veccost_Item.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veccost_Item[i].c_str(), &temp))
				{
					data.mcost_Item.push_back(temp);
				}
			}
		}
		{
			const char* reward = element->Attribute("reward");
			std::vector<std::string> vecreward;
			boost::split(vecreward, reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecreward[i].c_str(), &temp))
				{
					data.mreward.push_back(temp);
				}
			}
		}
		data.micon = element->Attribute("icon");
		data.msort = element->IntAttribute("sort");
		data.mcondition = element->IntAttribute("condition");
		data.mvalue = element->Attribute("value");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_shop Loaded. Load Data:%u", mMapData.size());
}

void M_shop::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_shop");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_shop");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_shopData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "shop_type", data.mshop_type);
		LuaCfgHelper::readVectorInt(L, "cost_Item", data.mcost_Item);
		LuaCfgHelper::readVectorInt(L, "reward", data.mreward);
		LuaCfgHelper::readString(L, "icon", data.micon);
		LuaCfgHelper::readInt(L, "sort", data.msort);
		LuaCfgHelper::readInt(L, "condition", data.mcondition);
		LuaCfgHelper::readString(L, "value", data.mvalue);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_shop Loaded. Load Data:%u", mMapData.size());
}

void M_shop::Reload()
{
	mMapData.clear();
	Load();
}

M_shop* M_shop::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_shop());
	}
	return msSingleton.get();
}

void M_shop::Release()
{
	msSingleton.reset(nullptr);
}
